<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Curse of Dimensionality</title>
    <link rel="stylesheet" href="../Css/styles.css">
    <link rel="stylesheet" id="themeStylesheet" href="../Css/light-theme.css"> <!-- thème clair par défaut -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.12.0/css/all.min.css">
</head>

<script src="https://cdnjs.cloudflare.com/ajax/libs/jsxgraph/1.3.5/jsxgraphcore.js"></script>
<script src="https://cdn.jsdelivr.net/npm/jsxgraph@1.3.5/dist/jsxgraphcore.js"></script>
<script src="https://d3js.org/d3.v6.min.js"></script>

<body>

    <section class="top-page">
        <header class="header">
            <nav class="nav">
                <li><a href="#intro">Introduction</a></li>
                <li><a href="#demo">Interactive Demo</a></li>
                <li><a href="#res">Resources</a></li>
            </nav>
            <button id="themeSwitch">Switch Theme</button> <!-- Bouton pour basculer entre les thèmes -->
            
        </header>
        <select id="langSelect"> <!-- Bouton language -->
            <option value="en">English</option>
            <option value="fr">Français</option>
        </select>
        
        <div class="landing-page">
            <h1 class="big-title">Curse of Dimensionality</h1>
            <a class="scroll-down" href="#end">Scroll <i class="fas fa-angle-down"></i></a>
        </div>

    </section>

    <section class="intro" id="intro">
        <h2 class="section-title">Introduction</h2>

        <p class="text">
            The "Curse of Dimensionality" is a complex phenomenon that affects the performance of machine learning and data mining algorithms when faced with high-dimensional datasets. This concept is essential for understanding the challenges faced by data scientists and machine learning engineers when working with large datasets.
        </p>
        <h3 class="text-title">What is Dimensionality ?</h3>
        <p class="text">
            The dimensionality of a dataset refers to the number of features or variables that compose it. For example, in a two-dimensional dataset, each data point is defined by two variables (or dimensions). As the number of dimensions increases, the space in which the data resides becomes vast and complex.
        </p>
        <h3 class="text-title">The Curse of Dimensionality</h3>
        <p class="text">
            The Curse of Dimensionality describes the negative phenomena that occur when the number of dimensions in a dataset becomes very high. These phenomena include increased data sparsity, increased distance between data points, and increased complexity of models needed to effectively process them.
        </p>
        <h3 class="text-title">Consequences and Challenges</h3>
        <p class="text">
            The Curse of Dimensionality presents several important consequences and challenges for practical applications in data science:
        </p>
        <p class="text-list">
            It can lead to increased computation time required for model training.
        </p>
        <p class="text-list">
            It may require much larger datasets to achieve reliable modeling performance.
        </p>
        <p class="text-list">
            It can result in poor model generalization, due to overfitting or underfitting to the data.
        </p>
        <p class="text">
            Understanding these challenges is crucial for developing effective solutions and data preprocessing techniques to overcome the Curse of Dimensionality and improve the performance of machine learning algorithms.
        </p>


    </section>

    <section class="demo" id="demo">
        <h2 class="section-title">Interactive Demo</h2>

        <div class="text">
            <p>
                Below, you will find an interactive demonstration to visualize concepts related to the Curse of Dimensionality. Here's an explanation of how it works:
            </p>
        </div>
        <div class="text">
            <h3>1. Parameter Selection:</h3>
            <ul>
                <li>
                    <strong>1. Number of dimensions:</strong> The number of dimensions of the hypercube is defined using the "Dimension" slider. Thus, the number of corners of the hypercube will be 2^dim corners. Note that, due to display issues, only a certain number of outer corners will be sampled, resulting in the number of samples being << 2^dim.
                    See the mathematical explanation and algorithm principle section for more details.
                </li>
                <li>
                    <strong>2. Number of samples:</strong> The number of samples in the display is also defined by entering it in the "Number of samples" bar, which determines the number of sample corners generated in the space between the circumscribed and inscribed circles (we will start by displaying the outermost corners). Note that the number of samples must be << 2^dim.
                </li>
                <li>
                    <strong>3. Vector w:</strong> The vector w from which the projection plane by Gram-Schmidt will be constructed is selectable using the "w" dropdown menu.
                    See the mathematical explanation and algorithm principle section for more details.
                </li>
            </ul>
        </div>
        <div class="text">
            <h3>2. Point Generation:</h3>
            <p class="text">
                When you adjust the sliders to choose the desired parameters, points are generated randomly in the multidimensional hypercube based on the values selected with the "Number of points" slider. Once the projection onto the plane is done, you will notice that the points are located inside the circumscribed circle.
                See the mathematical explanation and algorithm principle section for more details.
            </p>
        </div>
        <div class="text">
            <h3>3. Norm Histogram:</h3>
            <p class="text">
                A histogram is also generated to display the distribution of norms of the generated points. You can adjust the number of bars in the histogram using the "Number of bars" slider.
            </p>
        </div>

        <p class="text">
            ______________________________________________
        </p>



        <head>
            <meta charset="UTF-8">
            <title>Hypercube Projecion Demonstration </title>
            <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/jsxgraph/1.3.5/jsxgraph.css" />
            <style>
        
                #controls {
                    margin-top: 20px;
                    margin-left: 20px; 
                    background-color: #f1f1f1;
                    padding: 20px;
                }
        
                #graphs-container {
                    display: flex; 
                    gap: 20px; 
                    padding-left: 20px; 
                    margin-top: 20px; 
                }
        
                .jxgbox {
                    width: 1000px;
                    height: 1000px; 
                    border: 1px solid black;
                }
        
            </style>
        
        </head>
        <body>
            <div id="controls">
                <label for="dimension">Dimension:</label>
                <input type="number" id="dimension" min="3" max="100" value="3" />
                <label for="samples">Number of Samples:</label>
                <input type="number" id="samples" value="50" /> 
                <button id="refreshButton">Generate New Points</button>
                <!--
                 <input type="file" id="dataUpload" />
                <label for="bins">Number of Bins:</label>
                <input type="number" id="bins" min="1" max="200" value="20" />
                -->
            </div>
            <div id="graphs-container">
                <div id="graph1" class="jxgbox"></div>
            </div>
            <div id="info"></div>
            <script src="https://cdn.plot.ly/plotly-latest.min.js"></script>
            <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjs/9.5.0/math.min.js"></script>
            <script >
            document.addEventListener('DOMContentLoaded', function () {
            
                var currentD, currentN, currentPoints;
            
        
        
                function points(Dim, NumberOfPoints) {
                    let L = [];
                    for (let i = 0; i < NumberOfPoints; i++) {
                        let point = [];
                        for (let j = 0; j < Dim; j++) {
                            point[j] = Math.random() * 2 - 1;
                        }
                        L.push(point);
                    }
                      return L;
                }
            
                
                  
                function signVector(v) {
                  return math.map(v, val => math.sign(val));
                }
        
                
                
                function projectOnPlane(point, plan) {
                    let y1 = math.dot(point, plan[1]);
                    let y2 = math.dot(point, plan[2]);
                      return [y1, y2];
                }    
                
            
                function gramSchmidt(A) {
                    let W = math.multiply(1 / math.norm(A[0]), A[0]);
                    let e1 = math.subtract(A[1], math.multiply(math.dot(A[1], W), W));
                    e1 = math.multiply(1 / math.norm(e1), e1);
                    let e2 = math.subtract(A[2], math.multiply(math.dot(A[2], W), W));
                    e2 = math.subtract(e2, math.multiply(math.dot(e2, e1), e1));
                    e2 = math.multiply(1 / math.norm(e2), e2);
                      return [W, e1, e2];
              }
              
              
            
            
                function outsideSamples(Dim, numSamples, e1, e2) {
              
                    let samplesCorner = [];
                    for (let i = 0; i < numSamples; i++) {
                      let alpha = Math.random() * 2 - 1; 
                      let beta = Math.random() * 2 - 1;      
                      let v = math.add(math.multiply(alpha, e1), math.multiply(beta, e2));      
                      v = signVector(v.map(component => component / math.norm(v)));      
                      samplesCorner.push(v);
                  }      
                        return samplesCorner;
              }
              
              
              
                function scatter(Dim, preGeneratedPoints, numSamples) {
                    let Vect = gramSchmidt(points(Dim, Dim));
                     
                    let samplesPointsCube = outsideSamples(Dim, numSamples, Vect[1], Vect[2]);
                    let samplesPointsCubeProject = samplesPointsCube.map(point => projectOnPlane(point, Vect));
                    
                    let pointsProject = preGeneratedPoints.map(point => projectOnPlane(point, Vect));
            
                    var data = [
                        {
                            x: pointsProject.map(p => p[0]),
                            y: pointsProject.map(p => p[1]),
                            mode: 'markers',
                            type: 'scatter',
                            name: 'Points',
                            marker: { size: 3, color:  'black' }
                        }
                        
                        ,
                        {
                            x: samplesPointsCubeProject.map(p => p[0]),
                            y: samplesPointsCubeProject.map(p => p[1]),
                            mode: 'markers',
                            type: 'scatter',
                            name: 'OutsidePoints',
                            marker: { size: 6, color: 'red' }
                        }
                        
                    ];
                    
                    let layout = {
                        autosize: true,
            
                        title: 'Plot',
                        xaxis: {
                            title: 'X',
                            scaleanchor: "y",
                            scaleratio: 1,
                            gridwidth: 2
                        },
                        yaxis: {
                            title: 'Y',
                            gridwidth: 2
                        },
                        shapes: [
                            {
                                type: 'circle',
                                xref: 'x',
                                yref: 'y',
                                x0: -1,
                                y0: -1,
                                x1: 1,
                                y1: 1,
                                line: {
                                    color: 'blue',
                                    width: 2,
                                },
                            },
                            {
                                type: 'circle',
                                xref: 'x',
                                yref: 'y',
                                x0: -Math.sqrt(Dim),
                                y0: -Math.sqrt(Dim),
                                x1: Math.sqrt(Dim),
                                y1: Math.sqrt(Dim),
                                line: {
                                    color: 'blue',
                                    width: 2,
                                },
                            },
                        ],
                        template: 'plotly_dark',
                        legend: {
                            font: {
                                size: 10
                            }
                        }
                    };
                    
                    
                    Plotly.react('graph1', data, layout);
                    
                }
            
            
            
            function InputValidation() {
            
                var numberOfSamples = parseInt(document.getElementById('samples').value);
            
                    
                if (isNaN(numberOfSamples) || numberOfSamples <= 0) {
                    alert('Please enter a valid number of samples.');
                    return false;
                }
            
                return true;
            }
            
            
            
            
            function SetPoints() {
                if (!InputValidation()) {
                    return;
                }
                currentD = parseInt(document.getElementById('dimension').value);
                currentN = parseInt(document.getElementById('samples').value);
                currentPoints = points(currentD, currentN); 
            
            
            }
            
            
            
            function refresh() {
                if (!InputValidation() || !currentPoints) {
                    return;
                }
                scatter(currentD, currentPoints, currentD*currentD) ; 
            }
            
            
             
            
            
            document.getElementById('dimension').addEventListener('input', SetPoints);
            document.getElementById('samples').addEventListener('input', SetPoints);
            document.getElementById('refreshButton').addEventListener('click', refresh);
            
            SetPoints()
            });  
            </script>
        </body>
        </html>



    </section>

    <section class="res" id="res">
        <h2 class="section-title">Resources</h2>
        <p></p>
    </section>

    <footer id="end">
        <p class="copyright">&copy; 2024-Curse of Dimensionality</p>
        <a href="" class="more">more</a>
    </footer>


    
    
    <script src="../JavaScript/Projection_hypercube.js"></script>
    <script src="../JavaScript/Smooth_web_page.js"></script>

</body>
</html>

